# Open / Close Index API /启动关闭索引

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-open-close.html](https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-open-close.html)

译文链接 : [Open / Close Index API /启动关闭索引](/pages/viewpage.action?pageId=4882797)

贡献者 : [Le-Mon](/display/~tanwen)

注意：涉及翻译内容： Index-索引；types-类型；mapping-映射；aliases-别名；shards-分片；replicas-副本

启动关闭索引允许关闭一个索引并在之后重新开启，一个关闭的索引几乎不占用集群资源（除了维持本身的元信息），并且关闭的索引对读写操作锁定。一个关闭的索引可以重新开启，将通过常规的恢复进程开启。

REST 接口为  `/{index}/_close` 和 `/{index}/_open`. 例如:

```
curl -XPOST 'localhost:9200/my_index/_close?pretty'
curl -XPOST 'localhost:9200/my_index/_open?pretty'
```

同时开启/关闭多个索引也是允许的。如果请求不存在的索引会抛出错误，可以通过修改配置 `ignore_unavailable=true 阻止抛出错误。`

所有的索引都可以被开启/关闭只用使用 _all 或者采用通配符（例如 * ）作为索引名称。

通过 _all 或者通配符识别索引的方式可以通过修改配置 `action.destructive_requires_name=true 来禁用，这项配置也可以通过集群API修改更新。`

关闭索引需要消费大量的磁盘空间，可能会对现有环境造成问题。关闭索引的API可以通过集群设置API禁用：`cluster.indices.close.enable`= `false （默认为true），关闭。`