# Installing Elasticsearch（安装）

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/5.4/install-elasticsearch.html](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/install-elasticsearch.html)

译文链接 : [http://www.apache.wiki/pages/viewpage.action?pageId=4882613](http://www.apache.wiki/pages/viewpage.action?pageId=4882613)

贡献者 : [漫步](/display/~tianruilin)，[geekidentity](/display/~houfachao)，[ApacheCN](/display/~apachecn)，[Apache中文网](/display/~apachechina)

**Elasticsearch** 提供以下安装包的格式 : 

| 格式 | 说明 |
| --- | --- |
| **`zip`/`tar.gz`** | **zip** 和 **tar.gz** 的安装包适合在任何系统上安装，是针对 **Elasticsearch** [入门指南](/pages/viewpage.action?pageId=4260366)的最佳选择。[Install Elasticsearch with `.zip` or `.tar.gz`](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/zip-targz.html "Install Elasticsearch with .zip or .tar.gz") or [Install Elasticsearch on Windows](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/windows.html "Install Elasticsearch on Windows") |
| **deb** | **deb** 包适用于 **Debian**，**Ubuntu** 和其他基于 **Debian** 的系统。 **Debian** 软件包可以从 **Elasticsearch** 网站或我们的 **Debian** 仓库下载。[Install Elasticsearch with Debian Package](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/deb.html "Install Elasticsearch with Debian Package") |
| **rpm** | rpm包适合在Red Hat，Centos，SLES，OpenSuSE和其他基于RPM的系统上安装。 RPM可以从Elasticsearch网站或从我们的RPM仓库下载。[Install Elasticsearch with RPM](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/rpm.html "Install Elasticsearch with RPM") |
| **docker** | 使用镜像可将Elasticsearch在Docker容器运行。它预装了[X-Pack](https://www.elastic.co/guide/en/x-pack/5.2/index.html)，可以从Elastic Docker Registry下载。[Install Elasticsearch with Docker](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/docker.html "Install Elasticsearch with Docker") |

### Configuration Management Tools（配置管理工具）

我们还提供以下配置管理工具来帮助大型部署 : 

| **Puppet** | [puppet-elasticsearch](https://github.com/elastic/puppet-elasticsearch) |
| **Chef** | [cookbook-elasticsearch](https://github.com/elastic/cookbook-elasticsearch) |
| **Ansible** | [ansible-elasticsearch](https://github.com/elastic/ansible-elasticsearch) |