# Prefix Query(前缀查询)

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/current/query-dsl-prefix-query.html](https://www.elastic.co/guide/en/elasticsearch/reference/current/query-dsl-prefix-query.html)

译文链接 : [http://www.apache.wiki/pages/viewpage.action?pageId=4260632](http://www.apache.wiki/pages/editpage.action?pageId=4260632)

贡献者 : @小布丁

匹配包含具有指定前缀的项（**not analyzed**）的字段的文档。前缀查询对应 **Lucene** 的 **PrefixQuery** 。

以下匹配用户字段包含以 “ki” 开头的项的文档：

```
GET /_search
{ "query": {
    "prefix" : { "user" : "ki" }
  }
}
```

 **boost** 也可以和查询关联起来：

```
GET /_search
{ "query": {
    "prefix" : { "user" :  { "value" : "ki", "boost" : 2.0 } }
  }
}
```

或者和 **prefix** 语法配合（ _5.0.0_ _已经弃用_）：

```
GET /_search
{ "query": {
    "prefix" : { "user" :  { "prefix" : "ki", "boost" : 2.0 } }
  }
}
```

此多项查询允许您控制如何使用 [rewrite](https://www.elastic.co/guide/en/elasticsearch/reference/current/query-dsl-multi-term-rewrite.html) 参数重写。