# Keyword Marker Token Filter（Keyword Marker 词元过滤器）

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/current/analysis-keyword-marker-tokenfilter.html](https://www.elastic.co/guide/en/elasticsearch/reference/current/analysis-keyword-marker-tokenfilter.html)

译文链接 : [http://www.apache.wiki/pages/viewpage.action?pageId=10028553](http://www.apache.wiki/pages/viewpage.action?pageId=10028553)

贡献者 : [fucker](/display/~caizhongjie)，[ApacheCN](/display/~apachecn)，[Apache中文网](/display/~apachechina)

```
保护词语不被词干分析器修改。 必须放置在任何词干过滤器之前。
```

| 设置 | 描述 |
| --- | --- |
| `keywords` | 关键词列表. |
| `keywords_path` | 关键词列表文件的路径 (**`config` **`目录的相对路径或者绝对路径`). |
| `ignore_case` | 设置为 **`true`** 会把词转化为小写. 默认 **`false`**. |

示例：

```
index :
    analysis :
        analyzer :
            myAnalyzer :
                type : custom
                tokenizer : standard
                filter : [lowercase, protwords, porter_stem]
        filter :
            protwords :
                type : keyword_marker
                keywords_path : analysis/protwords.txt
```