# Create an Index（创建索引）

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/5.4/_create_an_index.html](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/_create_an_index.html)

译文链接 : [http://www.apache.wiki/pages/viewpage.action?pageId=4260694](http://www.apache.wiki/pages/viewpage.action?pageId=4260694)

贡献者 : [那伊抹微笑](/display/~wangyangting)，[ApacheCN](/display/~apachecn)，[Apache中文网](/display/~apachechina)

现在让我们创建一个名为 “**customer**” 的索引，然后再列出所有索引 : 

```
curl -XPUT 'localhost:9200/customer?pretty&pretty'
curl -XGET 'localhost:9200/_cat/indices?v&pretty'
```

这是第一个使用 **PUT** 动作命令创建名为 “**customer**” 的索引。我们简单的添加 **pretty** 到调用命令的末尾，来告诉它漂亮的打印成 **JSON** 响应（如果有的话）。

响应如下 : 

```
health status index    uuid                   pri rep docs.count docs.deleted store.size pri.store.size
yellow open   customer 95SQ4TSUT7mWBT7VNHH67A   5   1          0            0       260b           260b
```

第一个命令的结果告诉我们现在已经有 **1** 个名为 **customer** 的索引，并且它有 **5** 个主分片和 **1** 个副本（默认）以及它包含了 **0** 文档在索引中。

您可以也注意到 **customer** 索引有一个 **yellow** 标记在索引中。回想下我们先前讨论的 **yellow** 意味着有些副本没有被分配。该索引发生这种情的原因是因为 **Elasticsearch** 默认为该索引创建了 1 个副本。因为目前我们只有一个节点在运行，这一个副本不能够被分配（为了高可用性），直到稍候其它节点加入到集群。如果副本被分配到第二个节点，该索引的 **heath status**（健康状态）将会转换成 **green**。